Index: palm/trunk/SOURCE/advec_particles.f90
===================================================================
--- palm/trunk/SOURCE/advec_particles.f90	(revision 824)
+++ palm/trunk/SOURCE/advec_particles.f90	(revision 825)
@@ -609,101 +598,338 @@
                    pse = psi + prt_count(k,j,i)-1
 
-                   ALLOCATE( kern(psi:pse,psi:pse) )
-
-!
-!--                Calculate collision kernel for all particles in grid box
-                   CALL colker( i, j, k, kern )
-!
-!--                collison kernel is calculated in cm**3/s but needed in m**3/s
-                   kern = kern * 1.0E-6
-
-                   DO  n = pse, psi+1, -1
-
-                      integral = 0.0
-                      lw_max   = 0.0
-
-!
-!--                   Calculate growth of collector particle radius using all
-!--                   droplets smaller than current droplet 
-                      DO  is = psi, n-1
-
-                         integral = integral +                               &
-                                    ( particles(is)%radius**3 * kern(n,is) * &
-                                      particles(is)%weight_factor )
-!
-!--                      Calculate volume of liquid water of the collected
-!--                      droplets which is the maximum liquid water available
-!--                      for droplet growth   
-                         lw_max = lw_max + ( particles(is)%radius**3 * &
-                                             particles(is)%weight_factor )
+                   IF ( hall_kernel  .OR.  wang_kernel )  THEN
+
+                      ALLOCATE( kern(psi:pse,psi:pse) )
+
+!
+!--                   Calculate collision kernel for all particles in grid box
+                      CALL colker( i, j, k, kern )
+!
+!--                   Collison kernel is calculated in cm**3/s but needed
+!--                   in m**3/s
+                      kern = kern * 1.0E-6   ! to be moved to colker
+
+                      DO  n = pse, psi+1, -1
+
+                         integral = 0.0
+                         lw_max   = 0.0
+
+!
+!--                      Calculate growth of collector particle radius using all
+!--                      droplets smaller than current droplet 
+                         DO  is = psi, n-1
+
+                            integral = integral +                              &
+                                       ( particles(is)%radius**3 * kern(n,is) *&
+                                         particles(is)%weight_factor )
+!
+!--                         Calculate volume of liquid water of the collected
+!--                         droplets which is the maximum liquid water available
+!--                         for droplet growth   
+                            lw_max = lw_max + ( particles(is)%radius**3 * &
+                                                particles(is)%weight_factor )
+
+                         ENDDO
+
+!
+!--                      Change in radius of collector droplet due to collision
+                         delta_r = 1.0 / ( 3.0 * particles(n)%radius**2 ) * &
+                                   integral * dt_3d * ddx * ddy / dz 
+
+!
+!--                      Change in volume of collector droplet due to collision
+                         delta_v = particles(n)%weight_factor                  &
+                                   * ( ( particles(n)%radius + delta_r )**3    &
+                                       - particles(n)%radius**3 )
+
+                         IF ( lw_max < delta_v  .AND.  delta_v > 0.0 )  THEN
+!-- replace by message call
+                            PRINT*, 'Particle has grown to much because the',  &
+                                    ' change of volume of particle is larger', &
+                                    ' than liquid water available!'
+
+                         ELSEIF ( lw_max == delta_v  .AND.  delta_v > 0.0 ) THEN
+
+                            DO  is = psi, n-1
+
+                               particles(is)%weight_factor = 0.0
+                               particle_mask(is)  = .FALSE.
+                               deleted_particles = deleted_particles + 1
+
+                            ENDDO
+
+                         ELSEIF ( lw_max > delta_v  .AND.  delta_v > 0.0 )  THEN
+!
+!--                         Calculate new weighting factor of collected droplets
+                            DO  is = psi, n-1
+
+                               particles(is)%weight_factor = &
+                                  particles(is)%weight_factor - &
+                                  ( ( kern(n,is) * particles(is)%weight_factor &
+                                    / integral ) * delta_v )
+
+                               IF ( particles(is)%weight_factor < 0.0 )  THEN
+                                     WRITE( message_string, * ) 'negative ',   &
+                                                        'weighting factor: ',  &
+                                                     particles(is)%weight_factor
+                                     CALL message( 'advec_particles', '', 2, 2,&
+                                                   -1, 6, 1 )
+
+                               ELSEIF ( particles(is)%weight_factor == 0.0 )  &
+                               THEN
+
+                                   particles(is)%weight_factor = 0.0
+                                   particle_mask(is)  = .FALSE.
+                                   deleted_particles = deleted_particles + 1
+
+                               ENDIF
+
+                            ENDDO
+
+                         ENDIF
+
+                         particles(n)%radius = particles(n)%radius + delta_r
+                         ql_vp(k,j,i) = ql_vp(k,j,i) + &
+                                                    particles(n)%weight_factor &
+                                                    * particles(n)%radius**3
 
                       ENDDO
 
-!
-!--                   Change in radius of collector droplet due to collision
-                      delta_r = 1.0 / ( 3.0 * particles(n)%radius**2 ) * &
-                                integral * dt_3d * ddx * ddy / dz 
-
-!
-!--                   Change in volume of collector droplet due to collision
-                      delta_v = particles(n)%weight_factor                     &
-                                * ( ( particles(n)%radius + delta_r )**3       &
-                                    - particles(n)%radius**3 )
-
-                      IF ( lw_max < delta_v  .AND.  delta_v > 0.0 )  THEN
-
-                         PRINT*, 'Particle has grown to much because the       &
-                                  change of volume of particle is larger than  &
-                                  liquid water available!'
-
-                      ELSEIF ( lw_max == delta_v  .AND.  delta_v > 0.0 )  THEN
-
-                         DO  is = psi, n-1
-
-                            particles(is)%weight_factor = 0.0
-                            particle_mask(is)  = .FALSE.
-                            deleted_particles = deleted_particles + 1
-
+                      DEALLOCATE( kern )
+
+                   ELSEIF ( palm_kernel )  THEN
+!
+!--                   PALM collision kernel
+!
+!--                   Calculate the mean radius of all those particles which
+!--                   are of smaller size than the current particle and
+!--                   use this radius for calculating the collision efficiency
+                      DO  n = psi+prt_count(k,j,i)-1, psi+1, -1
+
+                         sl_r3 = 0.0
+                         sl_r4 = 0.0
+
+                         DO is = n-1, psi, -1
+                            IF ( particles(is)%radius < particles(n)%radius )  &
+                            THEN
+                               sl_r3 = sl_r3 + particles(is)%weight_factor     &
+                                             *( particles(is)%radius**3 )
+                               sl_r4 = sl_r4 + particles(is)%weight_factor     &
+                                             *( particles(is)%radius**4 )
+                            ENDIF
                          ENDDO
 
-                      ELSEIF ( lw_max > delta_v  .AND.  delta_v > 0.0 )  THEN
-!
-!--                      Calculate new weighting factor of collected droplets
-                         DO  is = psi, n-1
-
-                            particles(is)%weight_factor = &
-                               particles(is)%weight_factor - &
-                               ( ( kern(n,is) * particles(is)%weight_factor / &
-                                   integral ) * delta_v )
-
-                            IF ( particles(is)%weight_factor < 0.0 )  THEN
-                                  WRITE( message_string, * ) 'negative ',      &
+                         IF ( ( sl_r3 ) > 0.0 )  THEN
+                            mean_r = ( sl_r4 ) / ( sl_r3 )
+
+                            CALL collision_efficiency( mean_r,                 &
+                                                    particles(n)%radius,       &
+                                                    effective_coll_efficiency )
+
+                         ELSE
+                            effective_coll_efficiency = 0.0
+                         ENDIF
+
+                         IF ( effective_coll_efficiency > 1.0  .OR.            &
+                              effective_coll_efficiency < 0.0 )                &
+                         THEN
+                            WRITE( message_string, * )  'collision_efficien' , &
+                                   'cy out of range:' ,effective_coll_efficiency
+                            CALL message( 'advec_particles', 'PA0145', 2, 2,   &
+                                          -1, 6, 1 )
+                         ENDIF
+
+!
+!--                      Interpolation of ...
+                         ii = particles(n)%x * ddx
+                         jj = particles(n)%y * ddy
+                         kk = ( particles(n)%z + 0.5 * dz ) / dz
+
+                         x  = particles(n)%x - ii * dx
+                         y  = particles(n)%y - jj * dy
+                         aa = x**2          + y**2
+                         bb = ( dx - x )**2 + y**2
+                         cc = x**2          + ( dy - y )**2
+                         dd = ( dx - x )**2 + ( dy - y )**2
+                         gg = aa + bb + cc + dd
+
+                         ql_int_l = ( (gg-aa) * ql(kk,jj,ii)   + (gg-bb) *     &
+                                                              ql(kk,jj,ii+1)   &
+                                    + (gg-cc) * ql(kk,jj+1,ii) + ( gg-dd ) *   &
+                                                              ql(kk,jj+1,ii+1) &
+                                    ) / ( 3.0 * gg )
+
+                         ql_int_u = ( (gg-aa) * ql(kk+1,jj,ii)   + (gg-bb) *   &
+                                                            ql(kk+1,jj,ii+1)   &
+                                    + (gg-cc) * ql(kk+1,jj+1,ii) + (gg-dd) *   &
+                                                            ql(kk+1,jj+1,ii+1) &
+                                    ) / ( 3.0 * gg )
+
+                         ql_int = ql_int_l + ( particles(n)%z - zu(kk) ) / dz *&
+                                             ( ql_int_u - ql_int_l )
+
+!
+!--                      Interpolate u velocity-component
+                         ii = ( particles(n)%x + 0.5 * dx ) * ddx
+                         jj =   particles(n)%y * ddy
+                         kk = ( particles(n)%z + 0.5 * dz ) / dz ! only if eqist
+
+                         IF ( ( particles(n)%z - zu(kk) ) > (0.5*dz) ) kk = kk+1
+
+                         x  = particles(n)%x + ( 0.5 - ii ) * dx
+                         y  = particles(n)%y - jj * dy
+                         aa = x**2          + y**2
+                         bb = ( dx - x )**2 + y**2
+                         cc = x**2          + ( dy - y )**2
+                         dd = ( dx - x )**2 + ( dy - y )**2
+                         gg = aa + bb + cc + dd
+
+                         u_int_l = ( (gg-aa) * u(kk,jj,ii)   + (gg-bb) *       &
+                                                              u(kk,jj,ii+1)    &
+                                   + (gg-cc) * u(kk,jj+1,ii) + (gg-dd) *       &
+                                                              u(kk,jj+1,ii+1)  &
+                                   ) / ( 3.0 * gg ) - u_gtrans
+                         IF ( kk+1 == nzt+1 )  THEN
+                            u_int = u_int_l
+                         ELSE
+                            u_int_u = ( (gg-aa) * u(kk+1,jj,ii)   + (gg-bb) *  &
+                                                             u(kk+1,jj,ii+1)   &
+                                      + (gg-cc) * u(kk+1,jj+1,ii) + (gg-dd) *  &
+                                                             u(kk+1,jj+1,ii+1) &
+                                      ) / ( 3.0 * gg ) - u_gtrans
+                            u_int = u_int_l + ( particles(n)%z - zu(kk) ) / dz &
+                                              * ( u_int_u - u_int_l )
+                         ENDIF
+
+!
+!--                      Same procedure for interpolation of the v velocity-com-
+!--                      ponent (adopt index k from u velocity-component)
+                         ii =   particles(n)%x * ddx
+                         jj = ( particles(n)%y + 0.5 * dy ) * ddy
+
+                         x  = particles(n)%x - ii * dx
+                         y  = particles(n)%y + ( 0.5 - jj ) * dy
+                         aa = x**2          + y**2
+                         bb = ( dx - x )**2 + y**2
+                         cc = x**2          + ( dy - y )**2
+                         dd = ( dx - x )**2 + ( dy - y )**2
+                         gg = aa + bb + cc + dd
+
+                         v_int_l = ( ( gg-aa ) * v(kk,jj,ii)   + ( gg-bb ) *   &
+                                                               v(kk,jj,ii+1)   &
+                                   + ( gg-cc ) * v(kk,jj+1,ii) + ( gg-dd ) *   &
+                                                               v(kk,jj+1,ii+1) &
+                                   ) / ( 3.0 * gg ) - v_gtrans
+                         IF ( kk+1 == nzt+1 )  THEN
+                            v_int = v_int_l
+                         ELSE
+                            v_int_u = ( (gg-aa) * v(kk+1,jj,ii)   + (gg-bb) *  &
+                                                               v(kk+1,jj,ii+1) &
+                                      + (gg-cc) * v(kk+1,jj+1,ii) + (gg-dd) *  &
+                                                             v(kk+1,jj+1,ii+1) &
+                                      ) / ( 3.0 * gg ) - v_gtrans
+                            v_int = v_int_l + ( particles(n)%z - zu(kk) ) / dz &
+                                              * ( v_int_u - v_int_l )
+                         ENDIF
+
+!
+!--                      Same procedure for interpolation of the w velocity-com-
+!--                      ponent (adopt index i from v velocity-component)
+                         jj = particles(n)%y * ddy
+                         kk = particles(n)%z / dz
+
+                         x  = particles(n)%x - ii * dx
+                         y  = particles(n)%y - jj * dy
+                         aa = x**2          + y**2
+                         bb = ( dx - x )**2 + y**2
+                         cc = x**2          + ( dy - y )**2
+                         dd = ( dx - x )**2 + ( dy - y )**2
+                         gg = aa + bb + cc + dd
+
+                         w_int_l = ( ( gg-aa ) * w(kk,jj,ii)   + ( gg-bb ) *   &
+                                                                 w(kk,jj,ii+1) &
+                                   + ( gg-cc ) * w(kk,jj+1,ii) + ( gg-dd ) *   &
+                                                               w(kk,jj+1,ii+1) &
+                                   ) / ( 3.0 * gg )
+                         IF ( kk+1 == nzt+1 )  THEN
+                            w_int = w_int_l
+                         ELSE
+                            w_int_u = ( (gg-aa) * w(kk+1,jj,ii)   + (gg-bb) *  &
+                                                               w(kk+1,jj,ii+1) &
+                                      + (gg-cc) * w(kk+1,jj+1,ii) + (gg-dd) *  &
+                                                             w(kk+1,jj+1,ii+1) &
+                                      ) / ( 3.0 * gg )
+                            w_int = w_int_l + ( particles(n)%z - zw(kk) ) / dz &
+                                              * ( w_int_u - w_int_l )
+                         ENDIF
+
+!
+!--                      Change in radius due to collision
+                         delta_r = effective_coll_efficiency / 3.0             &
+                                   * pi * sl_r3 * ddx * ddy / dz               &
+                                   * SQRT( ( u_int - particles(n)%speed_x )**2 &
+                                         + ( v_int - particles(n)%speed_y )**2 &
+                                         + ( w_int - particles(n)%speed_z )**2 &
+                                         ) * dt_3d
+!
+!--                      Change in volume due to collision
+                         delta_v = particles(n)%weight_factor                  &
+                                   * ( ( particles(n)%radius + delta_r )**3    &
+                                       - particles(n)%radius**3 )
+
+!
+!--                      Check if collected particles provide enough LWC for
+!--                      volume change of collector particle
+                         IF ( delta_v >= sl_r3  .AND.  sl_r3 > 0.0 )  THEN
+
+                            delta_r = ( ( sl_r3/particles(n)%weight_factor )   &
+                                        + particles(n)%radius**3 )**( 1./3. )  &
+                                        - particles(n)%radius
+
+                            DO  is = n-1, psi, -1
+                               IF ( particles(is)%radius < &
+                                    particles(n)%radius )  THEN
+                                  particles(is)%weight_factor = 0.0
+                                  particle_mask(is) = .FALSE.
+                                  deleted_particles = deleted_particles + 1
+                               ENDIF
+                            ENDDO
+
+                         ELSE IF ( delta_v < sl_r3  .AND.  sl_r3 > 0.0 )  THEN
+
+                            DO  is = n-1, psi, -1
+                               IF ( particles(is)%radius < particles(n)%radius &
+                                    .AND.  sl_r3 > 0.0 )  THEN
+                                  particles(is)%weight_factor =                &
+                                               ( ( particles(is)%weight_factor &
+                                               * ( particles(is)%radius**3 ) ) &
+                                               - ( delta_v                     &
+                                               * particles(is)%weight_factor   &
+                                               * ( particles(is)%radius**3 )   &
+                                               / sl_r3 ) )                     &
+                                               / ( particles(is)%radius**3 )
+
+                                  IF ( particles(is)%weight_factor < 0.0 )  THEN
+                                     WRITE( message_string, * ) 'negative ',   &
                                                      'weighting factor: ',     &
                                                      particles(is)%weight_factor
-                                  CALL message( 'advec_particles', '', 2, 2,   &
-                                                -1, 6, 1 )
-
-                            ELSEIF ( particles(is)%weight_factor == 0.0 )  THEN
-
-                                particles(is)%weight_factor = 0.0
-                                particle_mask(is)  = .FALSE.
-                                deleted_particles = deleted_particles + 1
-
-                            ENDIF
-
-                         ENDDO
-
-                      ENDIF
-
-                      particles(n)%radius = particles(n)%radius + delta_r
-                      ql_vp(k,j,i) = ql_vp(k,j,i) + particles(n)%weight_factor &
-                                                    * particles(n)%radius**3
-
-                   ENDDO
+                                     CALL message( 'advec_particles', '', 2,   &
+                                                   2, -1, 6, 1 )
+                                  ENDIF
+                               ENDIF
+                            ENDDO
+                         ENDIF
+
+                         particles(n)%radius = particles(n)%radius + delta_r
+                         ql_vp(k,j,i) = ql_vp(k,j,i) +               &
+                                        particles(n)%weight_factor * &
+                                        ( particles(n)%radius**3 )
+                      ENDDO
+
+                   ENDIF  ! collision kernel
 
                    ql_vp(k,j,i) = ql_vp(k,j,i) + particles(psi)%weight_factor  &
                                                  * particles(psi)%radius**3
 
-                   DEALLOCATE( kern )
 
                 ELSE IF ( prt_count(k,j,i) == 1 )  THEN
